$(function (){
	var width = window.innerWidth, height = window.innerHeight;
	var isIE =false, isEdge = false;
	var flagMobile = ('ontouchstart' in window) ? true: false;
	
	$(window).on('resize', function(){	
		width = window.innerWidth;
		height = window.innerHeight;
		init();
	})
	
	$(document).ready(function(){
		init();
		
		var InstTest = new GameQuestion(inputJSONString, Question);
		InstTest.init();
				
		$("#end").click(function(){
			if($(this).hasClass("disabled")) return;
			InstTest.endExam();
		});
		$("#Prev").click(function(){
			if($(this).hasClass("disabled")) return;
			InstTest.gotoPrevQuestion();
		});
		$("#Next").click(function(){
			if($(this).hasClass("disabled")) return;
			InstTest.gotoNextQuestion();
		});
		$(".radio-list > label").click(function(){
			InstTest.selectedOption($(this).find("span.badge").text());
		});
	});
	
	function init(){
		$(".container").css({"height":(height-6)+"px"});
		if(width<705){
			$(".container").css({"width":(width-25)+"px"});
			$(".timer").css({right:"15px"});
		}else{
			$(".timer").css({right:(width-705)/2+"px"});
		}
		
		var addTop = 15;
		if(flagMobile){
			$(".container").css({"width":(width)+"px"});
			$(".timer").css({right:"15px"});
			addTop = 10;
		}
		
		$(".timer").css({top:$(".intro").height()-30});
		//$(".worksheet").css({"margin-top":$(".intro").height()});
	}
	
	var GameQuestion = function(pSetting,pQuest){
		var currProb=1, InterID, flagEnd = false;
		var Quest = pQuest[pSetting.categoryID], CtProblems = Quest.problems.length;
		var nums = getRandom(CtProblems,CtProblems);
		var times = 0, flagTesting=[];
		var thisobj = this;
		
		var mistake = '<div class="result"><div class="fail"><span><i class="glyphicon glyphicon-remove"></i></span> Your Answer </div></div>',
			correct = '<div class="result"><div class="correct"><span><i class="glyphicon glyphicon-ok"></i></span> Right Answer </div></div>',
			answer = '<div class="result"><div class="correct"><span><i class="glyphicon glyphicon-ok"></i></span> Right Answer </div></div>';
		
		for(var i=0;i<CtProblems;i++){
			flagTesting[i]=0;
		}
		
		function CountingTime(){
			times++;
			var Min = Math.floor(times/60), Sec = times%60;
			var strMin = ((Min>9) ? "" : "0") + Min, strSec = ((Sec>9) ? "" : "0") + Sec;
			$('.timer > span').text( strMin + " : " + strSec);
		};
		function UpdateProblem(){		
			$(".questNum").text("Question "+ currProb + " of " +  CtProblems);
			
			var prob = Quest.problems[nums[currProb-1]];
			
			$(".QuestTitle > span").html(prob.question);
			if(prob.image!=""){
				$(".descriptionImg").removeClass("hidden");
				$(".descriptionImg > img").attr('src', 'assets/images/' + prob.image);
			}else{
				$(".descriptionImg").addClass("hidden");
			}
			
			$(".radio-list > label > div > span.badge").each(function(ind, item){
				$(item).removeClass("badge-important").removeClass("badge-success").addClass("badge-info");
			});
				
			prob.options.forEach(function(opt, ind){
				$(".radio-list > label:nth-child(" + (ind+1) + ")")[0].children[1].innerHTML = opt;
				marginTB = ($($(".radio-list > label:nth-child(" + (ind+1) + ")")[0].children[1]).height() - 30)/2;
				$($(".radio-list > label:nth-child(" + (ind+1) + ")")[0].children[0]).css({"margin-top":marginTB});
				
			});
			
			
			$("#collapseOne").removeClass("in").addClass("out");
			var html = prob.hint.replace(/src="(?:[^'\/]*\/)*([^']+)"/g, "src='assets/images/$1'");			
			$("#collapseOne > div").html(html);
			
			if(flagTesting[currProb-1]!=0){
				displayMark();
			}
			
			MathJax.Hub.Queue(["Typeset",MathJax.Hub]);
			
			$("#Next").removeClass("disabled");
			$("#Prev").removeClass("disabled");
			if(currProb==1) $("#Prev").addClass("disabled");
			if(currProb==CtProblems && flagEnd) $("#Next").addClass("disabled");
			window.scrollTo(0, 0);
		};
		function displayMark(){
			var prob = Quest.problems[nums[currProb-1]];
			var correctID = 0;
			$(".radio-list > label > div > span.badge").each(function(ind, item){
				if($(item).text()===prob.Answer) correctID=ind+1;
			});
			
			if(correctID==flagTesting[currProb-1]){
				$(".radio-list > label > div > span.badge").each(function(ind, item){
					if(ind==correctID-1){
						$(item).removeClass("badge-info").addClass("badge-success");
					}
				});
				$(".radio-list > label").each(function(ind,item){
					if(ind==correctID-1){
						$($(item).children()[1]).append(correct);
					}
				});
			}else{
				var selID = Math.abs(flagTesting[currProb-1])-1;
				$(".radio-list > label > div > span.badge").each(function(ind, item){
					if(ind==selID){
						$(item).removeClass("badge-info").addClass("badge-important");
					}
					if(ind==correctID-1){
						$(item).removeClass("badge-info").addClass("badge-success");
					}
				});
				$(".radio-list > label").each(function(ind,item){
					if(ind==selID){
						$($(item).children()[1]).append(mistake);
					}
					if(ind==correctID-1){
						$($(item).children()[1]).append(answer);
					}
				});
			}
		}
		function disableButtons(){
			$("#Prev").addClass("disabled");
			$("#Next").addClass("disabled");
			$("#end").addClass("disabled");
		}
		
		this.init = function(){			
			InterID = setInterval(CountingTime, 1000);
			
			$("div.topic > div.propCont").text(Quest.category);
			UpdateProblem();
			
			var addTop = flagMobile ? 10 : 15;
			$(".timer").css({top:$(".intro").height()-30});
		};
		this.selectedOption = function(pOptID){
			if(flagTesting[currProb-1]==0 && !flagEnd){
				var currID = 0;
				$(".radio-list > label > div > span.badge").each(function(ind, item){
					if($(item).text()===pOptID) currID=ind+1;
				});
				var prob = Quest.problems[nums[currProb-1]];
				if(pOptID===prob.Answer){
					flagTesting[currProb-1]=currID;					
				}
				else{
					flagTesting[currProb-1]=-currID;
				}
				displayMark();
			}
		}
		this.gotoNextQuestion = function(){
			if(currProb<CtProblems){
				currProb++;
				UpdateProblem();
			}else{
				$("#Next").addClass("disabled");
				this.endExam();
			}
		};
		this.gotoPrevQuestion = function(){
			if(currProb>1){
				currProb--;
				UpdateProblem();
			}
		};
		this.endExam = function(){
			flagEnd = true;
			clearInterval(InterID);
			//disableButtons();
			$("#end").addClass("disabled");
			
			var CtCorrect = 0, CtMistake = 0, answer = 0;
			flagTesting.forEach(function(val){
				val>0 ? CtCorrect++ : val<0 ? CtMistake++ : answer++;
			});
			
			$(".total > div:nth-child(2) div.value").html((CtProblems-answer)+"/"+CtProblems);			
			$(".total > div:nth-child(2) div.descript").html("Total Number of Questions Answered");		

			$(".right > div:nth-child(2) div.value").html(CtCorrect+"/"+CtProblems);			
			$(".right > div:nth-child(2) div.descript").html("Total Correct Answers");		

			$(".mistake > div:nth-child(2) div.value").html(CtMistake+"/"+CtProblems);			
			$(".mistake > div:nth-child(2) div.descript").html("Total Wrong Answers");		
			
			var Min = Math.floor(times/60), Sec = times%60;
			var strMin = ((Min>9) ? "" : "0") + Min, strSec = ((Sec>9) ? "" : "0") + Sec;			

			$(".time > div:nth-child(2) div.value").html(strMin + ":" + strSec);			
			$(".time > div:nth-child(2) div.descript").html("Time Taken");
			
			$(".modal").modal("show");
		}
	}
	
	var getRandom = function(Range, length){
		var RndNum = [];
		while(RndNum.length<length){
			var flagExist = false;
			var n = Math.floor(Math.random()*Range);
			for(var j = 0; j < RndNum.length; j++){
				if(n==RndNum[j]){
					flagExist = true;
					break;
				}
			}
			if(!flagExist) RndNum.push(n);
		}
		return RndNum;
	};
	
});